'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableHead = require('@material-ui/core/TableHead');

var _TableHead2 = _interopRequireDefault(_TableHead);

var _TableBody = require('@material-ui/core/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableRow = require('@material-ui/core/TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Table);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Table.__proto__ || Object.getPrototypeOf(Table)).call.apply(_ref, [this].concat(args))), _this), _this.el = {
      root: _Table2.default,
      head: _TableHead2.default,
      body: _TableBody2.default,
      row: _TableRow2.default,
      cell: _TableCell2.default
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Table, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          cols = _props.cols,
          rows = _props.rows,
          horizontal = _props.horizontal,
          noHead = _props.noHead;


      var selected = {
        col: this.props.selectedCol,
        row: this.props.selectedRow
      };

      var el = this.el;


      var props = {
        root: this.props.props,
        head: this.props.headProps,
        headCell: this.props.headCellProps,
        body: this.props.bodyProps,
        row: this.props.rowProps,
        cell: this.props.cellProps
      };

      if (horizontal) return _react2.default.createElement(
        el.root,
        props.root,
        _react2.default.createElement(
          el.body,
          props.body,
          rows.map(function (row, i) {
            return cols.map(function (col, j) {
              return _react2.default.createElement(
                el.row,
                _extends({ key: 'row-' + i + '-col-' + j }, props.row),
                !noHead && _react2.default.createElement(
                  el.cell,
                  _extends({ variant: 'head' }, props.headCell),
                  col.label || col.prop
                ),
                _react2.default.createElement(
                  el.cell,
                  props.cell,
                  selected.row === i && selected.col === j && col.editor ? col.editor(rows[i][col.prop], i, j, rows[i]) : col.render ? col.render(rows[i][col.prop], i, j, rows[i]) : rows[i][col.prop]
                )
              );
            });
          })
        )
      );

      return _react2.default.createElement(
        el.root,
        props.root,
        !noHead && _react2.default.createElement(
          el.head,
          props.head,
          _react2.default.createElement(
            el.row,
            props.row,
            cols.map(function (col, i) {
              return _react2.default.createElement(
                el.cell,
                _extends({ key: 'col-' + i }, props.headCell),
                col.label || col.prop
              );
            })
          )
        ),
        _react2.default.createElement(
          el.body,
          props.body,
          rows.map(function (row, i) {
            return _react2.default.createElement(
              el.row,
              _extends({ key: 'row-' + i }, props.row),
              cols.map(function (col, j) {
                return _react2.default.createElement(
                  el.cell,
                  _extends({ key: 'row-' + i + '-col-' + j }, props.cell),
                  selected.row === i && selected.col === j && col.editor ? col.editor(row[col.prop], i, j, rows[i]) : col.render ? col.render(row[col.prop], i, j, rows[i]) : row[col.prop]
                );
              })
            );
          })
        )
      );
    }
  }]);

  return Table;
}(_react.Component);

Table.propTypes = {
  cols: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    prop: _propTypes2.default.string.isRequired,
    label: _propTypes2.default.string,
    render: _propTypes2.default.function,
    editor: _propTypes2.default.function
  })).isRequired,

  rows: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,

  props: _propTypes2.default.object,
  headProps: _propTypes2.default.object,
  headCellProps: _propTypes2.default.object,
  bodyProps: _propTypes2.default.object,
  rowProps: _propTypes2.default.object,
  cellProps: _propTypes2.default.object,

  horizontal: _propTypes2.default.bool,

  selectedCol: _propTypes2.default.number,
  selectedRow: _propTypes2.default.number,

  noHead: _propTypes2.default.bool
};
Table.defaultProps = {
  props: {},
  headProps: {},
  headCellProps: {},
  bodyProps: {},
  rowProps: {},
  cellProps: {},

  horizontal: false,

  selectedCol: -1,
  selectedRow: -1,

  noHead: false
};
exports.default = Table;